{"cells":[{"cell_type":"markdown","source":["### Tworzenie tabeli d_calendar\n","Aby uruchomić poniższy kod należy najpierw odmrozić jego zawartość.\n"],"metadata":{"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"},"jp-MarkdownHeadingCollapsed":true},"id":"f08628de-0f20-4a31-8cf3-e6b1bcebd525"},{"cell_type":"code","source":["from pyspark.sql import functions as F\n","\n","df = spark.createDataFrame([(1,)], [\"id\"]).withColumn(\"date\", F.explode(F.expr(\"sequence(to_date('2000-01-01'), to_date('2024-12-31'), interval 1 day)\"))).drop('id')\n","\n","df = df.withColumn(\"year\",F.concat(F.lit(\"Y-\"),F.year(\"date\")))\\\n",".withColumn(\"month\",F.concat(F.lit(\"M-\"),F.year('date'),F.lpad(F.month(\"date\"),2,'0')))\\\n",".withColumn('dayOfWeek',F.dayofweek('date'))\\\n",".withColumn(\"id\",F.concat(F.lit(\"D-\"),F.year('date'),F.lpad(F.month(\"date\"),2,'0'),F.lpad(F.dayofmonth(\"date\"),2,'0')))\\\n",".select('id','date','year','month','dayOfWeek')\n","\n","df.write.format('delta').mode('overwrite').saveAsTable('d_calendar')"],"outputs":[{"output_type":"display_data","data":{"application/vnd.livy.statement-meta+json":{"spark_pool":null,"statement_id":70,"statement_ids":[70],"livy_statement_state":"available","session_id":"725867aa-9b80-487a-9bbf-085b75efab6f","state":"finished","normalized_state":"finished","queued_time":"2024-08-06T10:56:43.0112619Z","session_start_time":null,"execution_start_time":"2024-08-06T10:56:43.4509039Z","execution_finish_time":"2024-08-06T10:56:48.3285274Z","parent_msg_id":"48fcefdc-b6c5-4564-9c3e-c2003e588040"},"text/plain":"StatementMeta(, 725867aa-9b80-487a-9bbf-085b75efab6f, 70, Finished, Available, Finished)"},"metadata":{}}],"execution_count":68,"metadata":{"jupyter":{"source_hidden":false,"outputs_hidden":false},"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"},"collapsed":false,"editable":false,"run_control":{"frozen":true}},"id":"cbfb5366-d90f-490c-aabe-39f9783a6217"},{"cell_type":"markdown","source":["### Klasa użytkowa do obsługi połączenia pyODBC"],"metadata":{"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"74cc646a-c3d5-4daf-96c6-24f723f345f5"},{"cell_type":"code","source":["class DatabaseConnection:\n","    import struct\n","    from itertools import chain, repeat\n","    import pyodbc\n","\n","    def __init__(self, pSqlEndpoint):\n","        vConnectionString = f\"Driver={{ODBC Driver 18 for SQL Server}};Server={pSqlEndpoint},1433;Encrypt=Yes;TrustServerCertificate=No\"\n","        token_object = mssparkutils.credentials.getToken(\"pbi\")\n","        encoded_bytes = bytes(self.chain.from_iterable(zip(bytes(token_object, \"UTF-8\"), self.repeat(0))))\n","        token_bytes = self.struct.pack(\"<i\", len(encoded_bytes)) + encoded_bytes\n","        attrs_before = {1256: token_bytes}\n","        vConnection = self.pyodbc.connect(vConnectionString, attrs_before=attrs_before)\n","        self.cursor = vConnection.cursor()\n","\n","    def get_query_results(self, pQuery):\n","        self.cursor.execute(pQuery)\n","        return self.cursor.fetchall()"],"outputs":[{"output_type":"display_data","data":{"application/vnd.livy.statement-meta+json":{"spark_pool":null,"statement_id":7,"statement_ids":[7],"livy_statement_state":"available","session_id":"cb3016c7-6c12-4dc9-ae6a-f74a14b67e01","state":"finished","normalized_state":"finished","queued_time":"2024-08-06T13:45:51.2936811Z","session_start_time":null,"execution_start_time":"2024-08-06T13:45:51.7748103Z","execution_finish_time":"2024-08-06T13:45:52.031894Z","parent_msg_id":"424ff111-036a-41e3-a1e5-121003122bc6"},"text/plain":"StatementMeta(, cb3016c7-6c12-4dc9-ae6a-f74a14b67e01, 7, Finished, Available, Finished)"},"metadata":{}}],"execution_count":5,"metadata":{"jupyter":{"source_hidden":false,"outputs_hidden":false},"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"5a453f64-cd36-4594-a886-706b47777bd4"},{"cell_type":"markdown","source":["### Pętla z użyciem pySpark"],"metadata":{"nteract":{"transient":{"deleting":false}}},"id":"9b340f95-4852-46c5-a3a4-25478ae890b0"},{"cell_type":"code","source":["from datetime import date, timedelta\n","\n","vStart = date(2024,7,1)\n","for vDay in [d for d in (vStart + timedelta(n) for n in range(30))]:\n","    vSql = \"select id from d_calendar where date = '{day}'\".format(day = vDay)\n","    vRes = spark.sql(vSql).collect()[0][0]"],"outputs":[{"output_type":"display_data","data":{"application/vnd.livy.statement-meta+json":{"spark_pool":null,"statement_id":4,"statement_ids":[4],"livy_statement_state":"available","session_id":"cb3016c7-6c12-4dc9-ae6a-f74a14b67e01","state":"finished","normalized_state":"finished","queued_time":"2024-08-06T13:43:33.3670963Z","session_start_time":null,"execution_start_time":"2024-08-06T13:43:47.6098862Z","execution_finish_time":"2024-08-06T13:44:26.2823528Z","parent_msg_id":"f235f1d6-f654-47c9-9f17-894cb8a1039d"},"text/plain":"StatementMeta(, cb3016c7-6c12-4dc9-ae6a-f74a14b67e01, 4, Finished, Available, Finished)"},"metadata":{}}],"execution_count":2,"metadata":{"jupyter":{"source_hidden":false,"outputs_hidden":false},"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"37d6552c-3638-4b06-9a3e-a54fe83ea433"},{"cell_type":"markdown","source":["### Utworzenie połączenia pyODBC"],"metadata":{"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"cf49a5ac-86f6-4699-8fb1-eb5398b2e718"},{"cell_type":"code","source":["dbConn = DatabaseConnection('ordve2dp5nduxpctrlp6b2zx7e-cmehm6ccefoetgd4t2ravzecui.datawarehouse.fabric.microsoft.com','lh_SQLConnectionTest')"],"outputs":[{"output_type":"display_data","data":{"application/vnd.livy.statement-meta+json":{"spark_pool":null,"statement_id":8,"statement_ids":[8],"livy_statement_state":"available","session_id":"cb3016c7-6c12-4dc9-ae6a-f74a14b67e01","state":"finished","normalized_state":"finished","queued_time":"2024-08-06T13:45:55.0493682Z","session_start_time":null,"execution_start_time":"2024-08-06T13:45:55.4324605Z","execution_finish_time":"2024-08-06T13:45:56.8721058Z","parent_msg_id":"6d124e6b-7525-402e-9dab-6ce67e99e579"},"text/plain":"StatementMeta(, cb3016c7-6c12-4dc9-ae6a-f74a14b67e01, 8, Finished, Available, Finished)"},"metadata":{}}],"execution_count":6,"metadata":{"jupyter":{"source_hidden":false,"outputs_hidden":false},"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"963cb722-4c4e-4a2e-9751-70e20cb111d7"},{"cell_type":"markdown","source":["### Pętla z użyciem pyODBC"],"metadata":{"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"306208b7-4c36-4cc5-a95b-2d705ea37b7c"},{"cell_type":"code","source":["from datetime import date, timedelta\n","\n","vStart = date(2024,7,1)\n","for vDay in [d for d in (vStart + timedelta(n) for n in range(30))]:\n","    vSql = \"select id from lh_SQLConnectionTest.dbo.d_calendar where date = '{day}'\".format(day = vDay)\n","    vWyn = dbConn.get_query_results(vSql)[0][0]"],"outputs":[{"output_type":"display_data","data":{"application/vnd.livy.statement-meta+json":{"spark_pool":null,"statement_id":9,"statement_ids":[9],"livy_statement_state":"available","session_id":"cb3016c7-6c12-4dc9-ae6a-f74a14b67e01","state":"finished","normalized_state":"finished","queued_time":"2024-08-06T13:45:58.909211Z","session_start_time":null,"execution_start_time":"2024-08-06T13:45:59.2575893Z","execution_finish_time":"2024-08-06T13:46:04.0881213Z","parent_msg_id":"6a3358db-6303-4fe8-b8e3-72e37e9ed3f7"},"text/plain":"StatementMeta(, cb3016c7-6c12-4dc9-ae6a-f74a14b67e01, 9, Finished, Available, Finished)"},"metadata":{}}],"execution_count":7,"metadata":{"jupyter":{"source_hidden":false,"outputs_hidden":false},"nteract":{"transient":{"deleting":false}},"microsoft":{"language":"python","language_group":"synapse_pyspark"}},"id":"4dc50c48-decb-4dbe-b1f9-bf64de1ce2c9"}],"metadata":{"kernel_info":{"name":"synapse_pyspark"},"kernelspec":{"name":"synapse_pyspark","language":"Python","display_name":"Synapse PySpark"},"language_info":{"name":"python"},"microsoft":{"language":"python","language_group":"synapse_pyspark","ms_spell_check":{"ms_spell_check_language":"en"}},"widgets":{},"nteract":{"version":"nteract-front-end@1.0.0"},"synapse_widget":{"version":"0.1","state":{}},"spark_compute":{"compute_id":"/trident/default"},"dependencies":{"lakehouse":{"known_lakehouses":[{"id":"1634fa32-48cd-44ca-9fb6-c13a63711984"}],"default_lakehouse":"1634fa32-48cd-44ca-9fb6-c13a63711984","default_lakehouse_name":"lh_SQLConnectionTest","default_lakehouse_workspace_id":"78760813-2142-495c-987c-9ea20ae482a2"},"environment":{}}},"nbformat":4,"nbformat_minor":5}